SystemOrganization addCategory: #GOODSPlatformSqueak!

!DateAndTime methodsFor: '*goodsplatformsqueak' stamp: 'avi 2/26/2004 16:56'!
goodsIsImmutable
	^ true! !

!Exception class methodsFor: '*goodsplatformsqueak' stamp: 'cds 4/3/2010 12:28'!
raiseSignal

	^self signal! !

!Exception class methodsFor: '*goodsplatformsqueak' stamp: 'cds 4/3/2010 12:28'!
raiseSignal: message

	^self signal: message! !

!Color class methodsFor: '*goodsplatformsqueak' stamp: 'cds 5/24/2010 00:19'!
goodsTransientFields
	^ #(#cachedDepth #cachedBitPattern )! !

!Character methodsFor: '*goodsplatformsqueak' stamp: 'avi 7/11/2004 11:58'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 5; nextInt32Put: value
	! !

KKClassMapper subclass: #KKSqueakClassMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSPlatformSqueak'!

!KKSqueakClassMapper class methodsFor: 'class initialization' stamp: 'cds 4/2/2010 10:44'!
initialize
	"self initialize"

	self makeDefault! !

!KKSqueakClassMapper methodsFor: 'api' stamp: 'cds 4/2/2010 10:44'!
findClassForName: aClassName

	"Object allSubclassesDoGently: [:class |
		((class respondsTo: #goodsClassName) and: [class goodsClassName = aClassName])
			ifTrue: [^ class]]."

	^ Smalltalk
		at: (aClassName findTokens: '.') last asSymbol
		ifAbsent: [self error: 'Could not find class for ', aClassName].! !

!KKSqueakClassMapper methodsFor: 'api' stamp: 'cds 5/24/2010 00:12'!
nameForClass: aClass

	^aClass name! !

!ObjectExplorerWrapper methodsFor: '*goodsplatformsqueak' stamp: 'avi 10/31/2003 11:50'!
contents

	(item respondsTo: #explorerContents) ifTrue: [^item explorerContents].
	"For all others, show named vars first, then indexed vars"
	^(item yourClass allInstVarNames asOrderedCollection withIndexCollect: [:each :index |
		self class
			with: (item instVarAt: index)
			name: each
			model: item]) ,
	((1 to: item basicSize) collect: [:index |
		self class
			with: (item basicAt: index)
			name: index printString
			model: item])! !

!Set class methodsFor: '*goodsplatformsqueak' stamp: 'avi 10/25/2003 03:21'!
arrayDescriptor
	^ KKVariableFieldContainer referenceField! !

!KKMetaclassDescriptor methodsFor: '*goodsplatformsqueak' stamp: 'cds 7/6/2006 13:09'!
objectFromStream: aStream forDatabase: aDatabase
	^ Smalltalk classNamed: (super objectFromStream: aStream forDatabase: aDatabase)
! !

!KKMetaclassDescriptor methodsFor: '*goodsplatformsqueak' stamp: 'cds 7/6/2006 12:28'!
writeObject: aClass onStream: aStream forDatabase: aDatabase
	super writeObject: aClass name onStream: aStream forDatabase: aDatabase
! !

!HashedCollection class methodsFor: '*GOODSPlatformSqueak' stamp: 'AndyKellens 12/13/2010 19:28'!
arrayDescriptor 
	^KKVariableFieldContainer  referenceField name: 'array'! !

KKTransport subclass: #KKSqueakTCPSocketTransport
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSPlatformSqueak'!

!KKSqueakTCPSocketTransport class methodsFor: 'class initialization' stamp: 'cds 4/1/2010 14:47'!
initialize
	"self initialize"
	self makeDefault! !

!KKSqueakTCPSocketTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:37'!
close
	"Close this transport"
	socket closeAndDestroy.
	socket := nil! !

!KKSqueakTCPSocketTransport methodsFor: 'initialize-release' stamp: 'cds 6/22/2008 16:34'!
initializeHost: hostname port: portNumber
	"Create and connect to specified host and port number."
	Socket initializeNetwork.
	socket := Socket newTCP 
				connectTo: (NetNameResolver addressForName: hostname)
				port: portNumber.
	(Delay forMilliseconds: 10) wait.
! !

!KKSqueakTCPSocketTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:38'!
isConnected
	"Answer true if the transport is connected to another endpoint and can send data, false otherwise."
	^socket notNil and: [socket isValid and: [socket isConnected]]! !

!KKSqueakTCPSocketTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:39'!
isDataAvailable
	"Answer true if there is data that can be read from the socket without blocking, false otherwise."
	^socket dataAvailable! !

!KKSqueakTCPSocketTransport methodsFor: 'api' stamp: 'cds 6/23/2008 10:49'!
receiveDataInto: aBuffer startingAt: i
	"Read available data into aBuffer starting at index i either until aBuffer is full or no data remains to be read.  Answer the number of bytes read or zero to indicate that the connection was closed by the other end."
	^socket receiveDataInto: aBuffer startingAt: i! !

!KKSqueakTCPSocketTransport methodsFor: 'api' stamp: 'cds 6/22/2008 16:39'!
sendData: aByteArray
	"Send the specified byte array to the server.  This should be an unbuffered Smalltalk-process blocking call."
	socket sendData: aByteArray! !

!KKIdentitySet methodsFor: '*goodsplatformsqueak' stamp: 'cds 4/12/2011 14:38'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	start := (database keyForObject: anObject) \\ array size + 1.
	finish := array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element yourself == anObject yourself])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element yourself == anObject yourself])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

KKAbstractStringDescriptor subclass: #KKWideStringDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSPlatformSqueak'!

!KKWideStringDescriptor methodsFor: 'as yet unclassified' stamp: 'AndyKellens 5/14/2012 19:53'!
objectFromStream: aStream forDatabase: aDatabase
	^ WideString fromByteArray: (super objectFromStream: aStream  forDatabase: aDatabase)! !

!ColorForm class methodsFor: '*goodsplatformsqueak' stamp: 'cds 5/24/2010 00:19'!
goodsTransientFields
	^ #(#cachedColormap #cachedDepth )! !

KKPlatform subclass: #KKSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSPlatformSqueak'!

!KKSqueakPlatform class methodsFor: 'class initialization' stamp: 'cds 4/1/2010 15:16'!
initialize

	"self initialize"
	KKPlatform default: self new! !

!KKSqueakPlatform methodsFor: 'special objects' stamp: 'cds 4/1/2010 15:17'!
addPlatformSpecialObjectsTo: specialObjects

	specialObjects 
		at: ActiveWorld
		put: -2! !

!KKSqueakPlatform methodsFor: 'garbage collection' stamp: 'CDavidShaffer 7/16/2013 10:38'!
garbageCollect

	Smalltalk garbageCollect! !

!KKSqueakPlatform methodsFor: 'garbage collection' stamp: 'CDavidShaffer 7/16/2013 10:39'!
garbageCollectMost

	Smalltalk garbageCollectMost! !

!KKSqueakPlatform methodsFor: 'factories' stamp: 'cds 4/1/2010 16:20'!
integerDictionary

	^PluggableDictionary integerDictionary ! !

!KKSqueakPlatform methodsFor: 'factories' stamp: 'cds 4/1/2010 16:21'!
weakIdentityKeyDictionary

	^WeakIdentityKeyDictionary new! !

Object subclass: #KKPackageExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSPlatformSqueak'!

!KKPackageExporter commentStamp: 'cds 4/21/2011 16:55' prior: 0!
Export GOODS for file-in to VisualWorks.  Requies PackageInfo-Exports which can be loaded with:

Installer ss
	project: 'PackageInfo';
	install: 'PackageInfo-Exporters'!

!KKPackageExporter class methodsFor: 'visualworks' stamp: 'CDavidShaffer 7/15/2013 22:44'!
exportVisualWorks

	VW5PackageExporter fileOutPackageNamed: 'GOODS' withNamespace: 'GOODS'.
	VW5PackageExporter fileOutPackageNamed: 'GOODSCollections' withNamespace: 'GOODS'.! !

!Object class methodsFor: '*goodsplatformsqueak' stamp: 'cds 5/24/2010 00:20'!
goodsVariableFieldDescriptor
	| container field |
	container := KKVariableFieldContainer new name: 'array'.
	field := self isBits
				ifFalse: [KKReferenceField new]
				ifTrue:
					[self isBytes
						ifTrue: [KKUnsignedIntegerField new size: 2]
						ifFalse: [KKUnsignedIntegerField new size: 4]].
	container fieldType: field.
	^ container
! !

!WideString class methodsFor: '*goodsplatformsqueak' stamp: 'AndyKellens 5/14/2012 19:53'!
goodsDescriptorClass 
	^KKWideStringDescriptor! !

!KKManualWriteBarrier class methodsFor: '*goodsplatformsqueak' stamp: 'cds 7/10/2008 12:02'!
initialize
	"self initialize"
	Smalltalk addToStartUpList: self.
	self startUp.! !

!KKManualWriteBarrier class methodsFor: '*goodsplatformsqueak' stamp: 'cds 7/10/2008 12:03'!
startUp
	BarrierRegistry := WeakRegistry new! !

!OrderedCollection class methodsFor: '*GOODSPlatformSqueak' stamp: 'AndyKellens 12/13/2010 19:27'!
arrayDescriptor 
	^KKVariableFieldContainer  referenceField name: 'array'! !

!Metaclass methodsFor: '*goodsplatformsqueak' stamp: 'cds 5/21/2010 16:26'!
goodsDescriptor
	| descriptor |
	descriptor :=  KKMetaclassDescriptor new className: 'Class'.
	descriptor addField: String goodsVariableFieldDescriptor.
	^ descriptor
! !
KKSqueakClassMapper initialize!
KKSqueakTCPSocketTransport initialize!
KKSqueakPlatform initialize!
KKManualWriteBarrier initialize!
